gtkmm: Gtk::TextIterBase Class Reference

gtkmm 4.23.2

Public Types | Public Member Functions | Static Public Member Functions | Protected Attributes | Related Symbols | List of all members
Gtk::TextIterBase Class Reference
TextView Classes

Common base class of TextIter and TextConstIter. More...

`#include <gtkmm/textiter.h>`

Inheritance diagram for Gtk::TextIterBase:
[legend]

## Public Types
using | iterator_category = std::bidirectional_iterator_tag
using | value_type = gunichar
using | difference_type = int
using | reference = value_type
using | pointer = void
using | SlotFindChar = sigc::slot<bool(gunichar)>
| A slot that will be called on each consecutive character.

## Public Member Functions
| TextIterBase (const TextIterBase & other) noexcept
TextIterBase & | operator= (const TextIterBase & other) noexcept
| TextIterBase (TextIterBase && other) noexcept
TextIterBase & | operator= (TextIterBase && other) noexcept
| TextIterBase ()
| TextIterBase (const GtkTextIter * gobject)
GtkTextIter * | gobj ()
| Provides access to the underlying C instance.
const GtkTextIter * | gobj () const
| Provides access to the underlying C instance.
value_type | operator* () const
| Alias for get_char().
| operator bool () const
| Alias for !is_end().
int | get_offset () const
| Returns the character offset of an iterator.
int | get_line () const
| Returns the line number containing the iterator.
int | get_line_offset () const
| Returns the character offset of the iterator, counting from the start of a newline-terminated line.
int | get_line_index () const
| Returns the byte index of the iterator, counting from the start of a newline-terminated line.
int | get_visible_line_offset () const
| Returns the offset in characters from the start of the line to the given iter, not counting characters that are invisible due to tags with the “invisible” flag toggled on.
int | get_visible_line_index () const
| Returns the number of bytes from the start of the line to the given iter, not counting bytes that are invisible due to tags with the “invisible” flag toggled on.
gunichar | get_char () const
| The Unicode character at this iterator is returned.
Glib::ustring | get_slice (const TextIterBase &end) const
| Returns the text in the given range.
Glib::ustring | get_text (const TextIterBase &end) const
| Returns text in the given range.
Glib::ustring | get_visible_slice (const TextIterBase &end) const
| Returns visible text in the given range.
Glib::ustring | get_visible_text (const TextIterBase &end) const
| Returns visible text in the given range.
bool | starts_tag (const Glib::RefPtr< const TextTag > & tag={}) const
| Returns true if tag is toggled on at exactly this point.
bool | ends_tag (const Glib::RefPtr< const TextTag > & tag={}) const
| Returns true if tag is toggled off at exactly this point.
bool | toggles_tag (const Glib::RefPtr< const TextTag > & tag={}) const
| Gets whether a range with tag applied to it begins or ends at iter.
bool | has_tag (const Glib::RefPtr< const TextTag > & tag) const
| Returns true if iter points to a character that is part of a range tagged with tag.
bool | editable (bool default_setting=true) const
| Returns whether the character at iter is within an editable region of text.
bool | can_insert (bool default_editability=true) const
| Considering the default editability of the buffer, and tags that affect editability, determines whether text inserted at iter would be editable.
bool | starts_word () const
| Determines whether iter begins a natural-language word.
bool | ends_word () const
| Determines whether iter ends a natural-language word.
bool | inside_word () const
| Determines whether the character pointed by iter is part of a natural-language word (as opposed to say inside some whitespace).
bool | starts_sentence () const
| Determines whether iter begins a sentence.
bool | ends_sentence () const
| Determines whether iter ends a sentence.
bool | inside_sentence () const
| Determines whether iter is inside a sentence (as opposed to in between two sentences, e.g. after a period and before the first letter of the next sentence).
bool | starts_line () const
| Returns true if iter begins a paragraph.
bool | ends_line () const
| Returns true if iter points to the start of the paragraph delimiter characters for a line.
bool | is_cursor_position () const
| Determine if iter is at a cursor position.
int | get_chars_in_line () const
| Returns the number of characters in the line containing iter, including the paragraph delimiters.
int | get_bytes_in_line () const
| Returns the number of bytes in the line containing iter, including the paragraph delimiters.
Pango::Language | get_language () const
| Returns the language in effect at iter.
bool | is_end () const
| Returns true if iter is the end iterator.
bool | is_start () const
| Returns true if iter is the first iterator in the buffer.
bool | forward_char ()
| Moves iter forward by one character offset.
bool | backward_char ()
| Moves backward by one character offset.
bool | forward_chars (int count)
| Moves count characters if possible.
bool | backward_chars (int count)
| Moves count characters backward, if possible.
bool | forward_line ()
| Moves iter to the start of the next line.
bool | backward_line ()
| Moves iter to the start of the previous line.
bool | forward_lines (int count)
| Moves count lines forward, if possible.
bool | backward_lines (int count)
| Moves count lines backward, if possible.
bool | forward_word_end ()
| Moves forward to the next word end.
bool | backward_word_start ()
| Moves backward to the previous word start.
bool | forward_word_ends (int count)
| Calls forward_word_end() up to count times.
bool | backward_word_starts (int count)
| Calls backward_word_start() up to count times.
bool | forward_visible_line ()
| Moves iter to the start of the next visible line.
bool | backward_visible_line ()
| Moves iter to the start of the previous visible line.
bool | forward_visible_lines (int count)
| Moves count visible lines forward, if possible.
bool | backward_visible_lines (int count)
| Moves count visible lines backward, if possible.
bool | forward_visible_word_end ()
| Moves forward to the next visible word end.
bool | backward_visible_word_start ()
| Moves backward to the previous visible word start.
bool | forward_visible_word_ends (int count)
| Calls forward_visible_word_end() up to count times.
bool | backward_visible_word_starts (int count)
| Calls backward_visible_word_start() up to count times.
bool | forward_sentence_end ()
| Moves forward to the next sentence end.
bool | backward_sentence_start ()
| Moves backward to the previous sentence start.
bool | forward_sentence_ends (int count)
| Calls forward_sentence_end() count times.
bool | backward_sentence_starts (int count)
| Calls backward_sentence_start() up to count times.
bool | forward_cursor_position ()
| Moves iter forward by a single cursor position.
bool | backward_cursor_position ()
| Like forward_cursor_position(), but moves backward.
bool | forward_cursor_positions (int count)
| Moves up to count cursor positions.
bool | backward_cursor_positions (int count)
| Moves up to count cursor positions.
bool | forward_visible_cursor_position ()
| Moves iter forward to the next visible cursor position.
bool | backward_visible_cursor_position ()
| Moves iter backward to the previous visible cursor position.
bool | forward_visible_cursor_positions (int count)
| Moves up to count visible cursor positions.
bool | backward_visible_cursor_positions (int count)
| Moves up to count visible cursor positions.
void | set_offset (int char_offset)
| Sets iter to point to char_offset.
void | set_line (int line_number)
| Moves iterator iter to the start of the line line_number.
void | set_line_offset (int char_on_line)
| Moves iter within a line, to a new character (not byte) offset.
void | set_line_index (int byte_on_line)
| Same as set_line_offset(), but works with a byte index.
void | forward_to_end ()
| Moves iter forward to the “end iterator”, which points one past the last valid character in the buffer.
bool | forward_to_line_end ()
| Moves the iterator to point to the paragraph delimiter characters.
void | set_visible_line_offset (int char_on_line)
| Like set_line_offset(), but the offset is in visible characters, i.e. text with a tag making it invisible is not counted in the offset.
void | set_visible_line_index (int byte_on_line)
| Like set_line_index(), but the index is in visible bytes, i.e. text with a tag making it invisible is not counted in the index.
bool | forward_to_tag_toggle (const Glib::RefPtr< const TextTag > & tag={})
| Moves forward to the next toggle (on or off) of the tag, or to the next toggle of any tag if tag is nullptr.
bool | backward_to_tag_toggle (const Glib::RefPtr< const TextTag > & tag={})
| Moves backward to the next toggle (on or off) of the tag, or to the next toggle of any tag if tag is nullptr.
bool | forward_find_char (const SlotFindChar & slot, const TextIterBase & limit)
| Advances this iterator, calling slot on each character.
bool | forward_find_char (const SlotFindChar & slot)
| Advances this iterator, calling slot on each character.
bool | backward_find_char (const SlotFindChar & slot, const TextIterBase & limit)
| Same as forward_find_char(const SlotFindChar& slot, const TextIterBase& limit), but goes backward.
bool | backward_find_char (const SlotFindChar & slot)
| Same as forward_find_char(const SlotFindChar& slot), but goes backward.
int | compare (const TextIterBase & rhs) const
| A qsort()-style function that returns negative if lhs is less than rhs, positive if lhs is greater than rhs, and 0 if they’re equal.
bool | in_range (const TextIterBase &start, const TextIterBase &end) const
| Checks whether iter falls in the range [ start, end).

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Attributes
GtkTextIter | gobject_

## Related Symbols
(Note that these are not member symbols.)
bool | operator== (const TextIterBase & lhs, const TextIterBase & rhs)
bool | operator!= (const TextIterBase & lhs, const TextIterBase & rhs)
bool | operator< (const TextIterBase & lhs, const TextIterBase & rhs)
bool | operator> (const TextIterBase & lhs, const TextIterBase & rhs)
bool | operator<= (const TextIterBase & lhs, const TextIterBase & rhs)
bool | operator>= (const TextIterBase & lhs, const TextIterBase & rhs)
Gtk::TextIterBase & | wrap (GtkTextIter * object)
const Gtk::TextIterBase & | wrap (const GtkTextIter * object)

## Detailed Description

Common base class of TextIter and TextConstIter.

You don't create objects of this base class. Objects shall be either TextIter or TextConstIter.

See also
  TextIter

## Member Typedef Documentation

## ◆ difference_type

using Gtk::TextIterBase::difference_type = int

## ◆ iterator_category

using Gtk::TextIterBase::iterator_category = std::bidirectional_iterator_tag

## ◆ pointer

using Gtk::TextIterBase::pointer = void

## ◆ reference

using Gtk::TextIterBase::reference = value_type

## ◆ SlotFindChar

using Gtk::TextIterBase::SlotFindChar = sigc::slot<bool(gunichar)>

A slot that will be called on each consecutive character.

forward_find_char() and backward_find_char() advance the iterator one character at a time until the slot returns true.

For instance,

bool on_find_char(gunichar ch);

Since gtkmm 3.90

## ◆ value_type

using Gtk::TextIterBase::value_type = gunichar

## Constructor & Destructor Documentation

## ◆ TextIterBase() [1/4]

Gtk::TextIterBase::TextIterBase | ( | const TextIterBase & | other | ) |
| noexcept

## ◆ TextIterBase() [2/4]

Gtk::TextIterBase::TextIterBase | ( | TextIterBase && | other | ) |
| noexcept

## ◆ TextIterBase() [3/4]

Gtk::TextIterBase::TextIterBase | ( |  | ) |

## ◆ TextIterBase() [4/4]

Gtk::TextIterBase::TextIterBase | ( | const GtkTextIter * | gobject | ) |
| explicit

## Member Function Documentation

## ◆ backward_char()

bool Gtk::TextIterBase::backward_char | ( |  | ) |

Moves backward by one character offset.

Returns
  Whether movement was possible.

## ◆ backward_chars()

bool Gtk::TextIterBase::backward_chars | ( | int | count | ) |

Moves count characters backward, if possible.

If count would move past the start or end of the buffer, moves to the start or end of the buffer.

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn’t move, or moved onto the end iterator, then false is returned. If count is 0, the function does nothing and returns false.

Parameters

  count | Number of characters to move.

Returns
  Whether iter moved and is dereferenceable.

## ◆ backward_cursor_position()

bool Gtk::TextIterBase::backward_cursor_position | ( |  | ) |

Like forward_cursor_position(), but moves backward.

Returns
  true if we moved.

## ◆ backward_cursor_positions()

bool Gtk::TextIterBase::backward_cursor_positions | ( | int | count | ) |

Moves up to count cursor positions.

See forward_cursor_position() for details.

Parameters

  count | Number of positions to move.

Returns
  true if we moved and the new position is dereferenceable.

## ◆ backward_find_char() [1/2]

bool Gtk::TextIterBase::backward_find_char | ( | const SlotFindChar & | slot | ) |

Same as forward_find_char(const SlotFindChar& slot), but goes backward.

Parameters

  slot | Function to be called on each character.

Returns
  Whether a match was found.

## ◆ backward_find_char() [2/2]

bool Gtk::TextIterBase::backward_find_char | ( | const SlotFindChar & | slot,
|  | const TextIterBase & | limit )

Same as forward_find_char(const SlotFindChar& slot, const TextIterBase& limit), but goes backward.

Parameters

  slot | Function to be called on each character.
  limit | Search limit.

Returns
  Whether a match was found.

## ◆ backward_line()

bool Gtk::TextIterBase::backward_line | ( |  | ) |

Moves iter to the start of the previous line.

Returns
  Whether iter moved.

## ◆ backward_lines()

bool Gtk::TextIterBase::backward_lines | ( | int | count | ) |

Moves count lines backward, if possible.

If count would move past the start or end of the buffer, moves to the start or end of the buffer.

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn’t move, or moved onto the end iterator, then false is returned. If count is 0, the function does nothing and returns false. If count is negative, moves forward by 0 - count lines.

Parameters

  count | Number of lines to move backward.

Returns
  Whether iter moved and is dereferenceable.

## ◆ backward_sentence_start()

bool Gtk::TextIterBase::backward_sentence_start | ( |  | ) |

Moves backward to the previous sentence start.

If iter is already at the start of a sentence, moves backward to the next one.

Sentence boundaries are determined by Pango and should be correct for nearly any language.

Returns
  true if iter moved and is not the end iterator.

## ◆ backward_sentence_starts()

bool Gtk::TextIterBase::backward_sentence_starts | ( | int | count | ) |

Calls backward_sentence_start() up to count times.

If count is negative, moves forward instead of backward.

Parameters

  count | Number of sentences to move.

Returns
  true if iter moved and is not the end iterator.

## ◆ backward_to_tag_toggle()

bool Gtk::TextIterBase::backward_to_tag_toggle | ( | const Glib::RefPtr< const TextTag > & | tag = {} | ) |

Moves backward to the next toggle (on or off) of the tag, or to the next toggle of any tag if tag is nullptr.

If no matching tag toggles are found, returns false, otherwise true. Does not return toggles located at iter, only toggles before iter. Sets iter to the location of the toggle, or the start of the buffer if no toggle is found.

Parameters

  tag | A Gtk::TextTag.

Returns
  Whether we found a tag toggle before iter.

## ◆ backward_visible_cursor_position()

bool Gtk::TextIterBase::backward_visible_cursor_position | ( |  | ) |

Moves iter backward to the previous visible cursor position.

See backward_cursor_position() for details.

Returns
  true if we moved and the new position is dereferenceable.

## ◆ backward_visible_cursor_positions()

bool Gtk::TextIterBase::backward_visible_cursor_positions | ( | int | count | ) |

Moves up to count visible cursor positions.

See backward_cursor_position() for details.

Parameters

  count | Number of positions to move.

Returns
  true if we moved and the new position is dereferenceable.

## ◆ backward_visible_line()

bool Gtk::TextIterBase::backward_visible_line | ( |  | ) |

Moves iter to the start of the previous visible line.

Returns
  Whether iter moved.

## ◆ backward_visible_lines()

bool Gtk::TextIterBase::backward_visible_lines | ( | int | count | ) |

Moves count visible lines backward, if possible.

If count would move past the start or end of the buffer, moves to the start or end of the buffer.

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn’t move, or moved onto the end iterator, then false is returned. If count is 0, the function does nothing and returns false. If count is negative, moves forward by 0 - count lines.

Parameters

  count | Number of lines to move backward.

Returns
  Whether iter moved and is dereferenceable.

## ◆ backward_visible_word_start()

bool Gtk::TextIterBase::backward_visible_word_start | ( |  | ) |

Moves backward to the previous visible word start.

If iter is currently on a word start, moves backward to the next one after that.

Word breaks are determined by Pango and should be correct for nearly any language.

Returns
  true if iter moved and is not the end iterator.

## ◆ backward_visible_word_starts()

bool Gtk::TextIterBase::backward_visible_word_starts | ( | int | count | ) |

Calls backward_visible_word_start() up to count times.

Parameters

  count | Number of times to move.

Returns
  true if iter moved and is not the end iterator.

## ◆ backward_word_start()

bool Gtk::TextIterBase::backward_word_start | ( |  | ) |

Moves backward to the previous word start.

If iter is currently on a word start, moves backward to the next one after that.

Word breaks are determined by Pango and should be correct for nearly any language

Returns
  true if iter moved and is not the end iterator.

## ◆ backward_word_starts()

bool Gtk::TextIterBase::backward_word_starts | ( | int | count | ) |

Calls backward_word_start() up to count times.

Parameters

  count | Number of times to move.

Returns
  true if iter moved and is not the end iterator.

## ◆ can_insert()

bool Gtk::TextIterBase::can_insert | ( | bool | default_editability = true | ) | const

Considering the default editability of the buffer, and tags that affect editability, determines whether text inserted at iter would be editable.

If text inserted at iter would be editable then the user should be allowed to insert text at iter. Gtk::TextBuffer::insert_interactive() uses this function to decide whether insertions are allowed at a given position.

Parameters

  default_editability | true if text is editable by default.

Returns
  Whether text inserted at iter would be editable.

## ◆ compare()

int Gtk::TextIterBase::compare | ( | const TextIterBase & | rhs | ) | const

A qsort()-style function that returns negative if lhs is less than rhs, positive if lhs is greater than rhs, and 0 if they’re equal.

Ordering is in character offset order, i.e. the first character in the buffer is less than the second character in the buffer.

Parameters

  rhs | Another Gtk::TextIter.

Returns
  -1 if lhs is less than rhs, 1 if lhs is greater, 0 if they are equal.

## ◆ editable()

bool Gtk::TextIterBase::editable | ( | bool | default_setting = true | ) | const

Returns whether the character at iter is within an editable region of text.

Non-editable text is “locked” and can’t be changed by the user via Gtk::TextView. If no tags applied to this text affect editability, default_setting will be returned.

You don’t want to use this function to decide whether text can be inserted at iter, because for insertion you don’t want to know whether the char at iter is inside an editable range, you want to know whether a new character inserted at iter would be inside an editable range. Use can_insert() to handle this case.

Parameters

  default_setting | true if text is editable by default.

Returns
  Whether iter is inside an editable range.

## ◆ ends_line()

bool Gtk::TextIterBase::ends_line | ( |  | ) | const

Returns true if iter points to the start of the paragraph delimiter characters for a line.

Delimiters will be either a newline, a carriage return, a carriage return followed by a newline, or a Unicode paragraph separator character.

Note that an iterator pointing to the \n of a \r\n pair will not be counted as the end of a line, the line ends before the \r. The end iterator is considered to be at the end of a line, even though there are no paragraph delimiter chars there.

Returns
  Whether iter is at the end of a line.

## ◆ ends_sentence()

bool Gtk::TextIterBase::ends_sentence | ( |  | ) | const

Determines whether iter ends a sentence.

Sentence boundaries are determined by Pango and should be correct for nearly any language.

Returns
  true if iter is at the end of a sentence.

## ◆ ends_tag()

bool Gtk::TextIterBase::ends_tag | ( | const Glib::RefPtr< const TextTag > & | tag = {} | ) | const

Returns true if tag is toggled off at exactly this point.

If tag is nullptr, returns true if any tag is toggled off at this point.

Note that if this function returns true, it means that iter is at the end of the tagged range, but that the character at iter is outside the tagged range. In other words, unlike starts_tag(), if this function returns true, has_tag() will return false for the same parameters.

Parameters

  tag | A Gtk::TextTag.

Returns
  Whether iter is the end of a range tagged with tag.

## ◆ ends_word()

bool Gtk::TextIterBase::ends_word | ( |  | ) | const

Determines whether iter ends a natural-language word.

Word breaks are determined by Pango and should be correct for nearly any language.

Returns
  true if iter is at the end of a word.

## ◆ forward_char()

bool Gtk::TextIterBase::forward_char | ( |  | ) |

Moves iter forward by one character offset.

Note that images embedded in the buffer occupy 1 character slot, so this function may actually move onto an image instead of a character, if you have images in your buffer. If iter is the end iterator or one character before it, iter will now point at the end iterator, and this function returns false for convenience when writing loops.

Returns
  Whether iter moved and is dereferenceable.

## ◆ forward_chars()

bool Gtk::TextIterBase::forward_chars | ( | int | count | ) |

Moves count characters if possible.

If count would move past the start or end of the buffer, moves to the start or end of the buffer.

The return value indicates whether the new position of iter is different from its original position, and dereferenceable (the last iterator in the buffer is not dereferenceable). If count is 0, the function does nothing and returns false.

Parameters

  count | Number of characters to move, may be negative.

Returns
  Whether iter moved and is dereferenceable.

## ◆ forward_cursor_position()

bool Gtk::TextIterBase::forward_cursor_position | ( |  | ) |

Moves iter forward by a single cursor position.

Cursor positions are (unsurprisingly) positions where the cursor can appear. Perhaps surprisingly, there may not be a cursor position between all characters. The most common example for European languages would be a carriage return/newline sequence.

For some Unicode characters, the equivalent of say the letter “a” with an accent mark will be represented as two characters, first the letter then a "combining mark" that causes the accent to be rendered; so the cursor can’t go between those two characters.

See also the Pango::LogAttr struct and the pango_break() function.

Returns
  true if we moved and the new position is dereferenceable.

## ◆ forward_cursor_positions()

bool Gtk::TextIterBase::forward_cursor_positions | ( | int | count | ) |

Moves up to count cursor positions.

See forward_cursor_position() for details.

Parameters

  count | Number of positions to move.

Returns
  true if we moved and the new position is dereferenceable.

## ◆ forward_find_char() [1/2]

bool Gtk::TextIterBase::forward_find_char | ( | const SlotFindChar & | slot | ) |

Advances this iterator, calling slot on each character.

If slot returns true, forward_find_char() returns true and stops scanning. If slot never returns true, this iterator is set to the end iterator.

Parameters

  slot | A function to be called on each character.

Returns
  Whether a match was found.

## ◆ forward_find_char() [2/2]

bool Gtk::TextIterBase::forward_find_char | ( | const SlotFindChar & | slot,
|  | const TextIterBase & | limit )

Advances this iterator, calling slot on each character.

If slot returns true, forward_find_char() returns true and stops scanning. If slot never returns true, this iterator is set to limit.

Parameters

  slot | A function to be called on each character.
  limit | Search limit.

Returns
  Whether a match was found.

## ◆ forward_line()

bool Gtk::TextIterBase::forward_line | ( |  | ) |

Moves iter to the start of the next line.

If the iter is already on the last line of the buffer, moves the iter to the end of the current line. If after the operation, the iter is at the end of the buffer and not dereferenceable, returns false. Otherwise, returns true.

Returns
  Whether iter can be dereferenced.

## ◆ forward_lines()

bool Gtk::TextIterBase::forward_lines | ( | int | count | ) |

Moves count lines forward, if possible.

If count would move past the start or end of the buffer, moves to the start or end of the buffer.

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn’t move, or moved onto the end iterator, then false is returned. If count is 0, the function does nothing and returns false. If count is negative, moves backward by 0 - count lines.

Parameters

  count | Number of lines to move forward.

Returns
  Whether iter moved and is dereferenceable.

## ◆ forward_sentence_end()

bool Gtk::TextIterBase::forward_sentence_end | ( |  | ) |

Moves forward to the next sentence end.

If iter is at the end of a sentence, moves to the next end of sentence.

Sentence boundaries are determined by Pango and should be correct for nearly any language.

Returns
  true if iter moved and is not the end iterator.

## ◆ forward_sentence_ends()

bool Gtk::TextIterBase::forward_sentence_ends | ( | int | count | ) |

Calls forward_sentence_end() count times.

If count is negative, moves backward instead of forward.

Parameters

  count | Number of sentences to move.

Returns
  true if iter moved and is not the end iterator.

## ◆ forward_to_end()

void Gtk::TextIterBase::forward_to_end | ( |  | ) |

Moves iter forward to the “end iterator”, which points one past the last valid character in the buffer.

get_char() called on the end iterator returns 0, which is convenient for writing loops.

## ◆ forward_to_line_end()

bool Gtk::TextIterBase::forward_to_line_end | ( |  | ) |

Moves the iterator to point to the paragraph delimiter characters.

The possible characters are either a newline, a carriage return, a carriage return/newline in sequence, or the Unicode paragraph separator character.

If the iterator is already at the paragraph delimiter characters, moves to the paragraph delimiter characters for the next line. If iter is on the last line in the buffer, which does not end in paragraph delimiters, moves to the end iterator (end of the last line), and returns false.

Returns
  true if we moved and the new location is not the end iterator.

## ◆ forward_to_tag_toggle()

bool Gtk::TextIterBase::forward_to_tag_toggle | ( | const Glib::RefPtr< const TextTag > & | tag = {} | ) |

Moves forward to the next toggle (on or off) of the tag, or to the next toggle of any tag if tag is nullptr.

If no matching tag toggles are found, returns false, otherwise true. Does not return toggles located at iter, only toggles after iter. Sets iter to the location of the toggle, or to the end of the buffer if no toggle is found.

Parameters

  tag | A Gtk::TextTag.

Returns
  Whether we found a tag toggle after iter.

## ◆ forward_visible_cursor_position()

bool Gtk::TextIterBase::forward_visible_cursor_position | ( |  | ) |

Moves iter forward to the next visible cursor position.

See forward_cursor_position() for details.

Returns
  true if we moved and the new position is dereferenceable.

## ◆ forward_visible_cursor_positions()

bool Gtk::TextIterBase::forward_visible_cursor_positions | ( | int | count | ) |

Moves up to count visible cursor positions.

See forward_cursor_position() for details.

Parameters

  count | Number of positions to move.

Returns
  true if we moved and the new position is dereferenceable.

## ◆ forward_visible_line()

bool Gtk::TextIterBase::forward_visible_line | ( |  | ) |

Moves iter to the start of the next visible line.

Returns
  Whether iter can be dereferenced.

## ◆ forward_visible_lines()

bool Gtk::TextIterBase::forward_visible_lines | ( | int | count | ) |

Moves count visible lines forward, if possible.

If count would move past the start or end of the buffer, moves to the start or end of the buffer.

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn’t move, or moved onto the end iterator, then false is returned. If count is 0, the function does nothing and returns false. If count is negative, moves backward by 0 - count lines.

Parameters

  count | Number of lines to move forward.

Returns
  Whether iter moved and is dereferenceable.

## ◆ forward_visible_word_end()

bool Gtk::TextIterBase::forward_visible_word_end | ( |  | ) |

Moves forward to the next visible word end.

If iter is currently on a word end, moves forward to the next one after that.

Word breaks are determined by Pango and should be correct for nearly any language

Returns
  true if iter moved and is not the end iterator.

## ◆ forward_visible_word_ends()

bool Gtk::TextIterBase::forward_visible_word_ends | ( | int | count | ) |

Calls forward_visible_word_end() up to count times.

Parameters

  count | Number of times to move.

Returns
  true if iter moved and is not the end iterator.

## ◆ forward_word_end()

bool Gtk::TextIterBase::forward_word_end | ( |  | ) |

Moves forward to the next word end.

If iter is currently on a word end, moves forward to the next one after that.

Word breaks are determined by Pango and should be correct for nearly any language.

Returns
  true if iter moved and is not the end iterator.

## ◆ forward_word_ends()

bool Gtk::TextIterBase::forward_word_ends | ( | int | count | ) |

Calls forward_word_end() up to count times.

Parameters

  count | Number of times to move.

Returns
  true if iter moved and is not the end iterator.

## ◆ get_bytes_in_line()

int Gtk::TextIterBase::get_bytes_in_line | ( |  | ) | const

Returns the number of bytes in the line containing iter, including the paragraph delimiters.

Returns
  Number of bytes in the line.

## ◆ get_char()

gunichar Gtk::TextIterBase::get_char | ( |  | ) | const

The Unicode character at this iterator is returned.

Equivalent to operator* on a C++ iterator. If the element at this iterator is a non-character element, such as an image embedded in the buffer, the Unicode “unknown” character 0xFFFC is returned. If invoked on the end iterator, zero is returned; zero is not a valid Unicode character.

So you can write a loop which ends when this function returns 0.

Returns
  A Unicode character, or 0 if iter is not dereferenceable.

## ◆ get_chars_in_line()

int Gtk::TextIterBase::get_chars_in_line | ( |  | ) | const

Returns the number of characters in the line containing iter, including the paragraph delimiters.

Returns
  Number of characters in the line.

## ◆ get_language()

Pango::Language Gtk::TextIterBase::get_language | ( |  | ) | const

Returns the language in effect at iter.

If no tags affecting language apply to iter, the return value is identical to that of gtk_get_default_language().

Returns
  Language in effect at iter.

## ◆ get_line()

int Gtk::TextIterBase::get_line | ( |  | ) | const

Returns the line number containing the iterator.

Lines in a Gtk::TextBuffer are numbered beginning with 0 for the first line in the buffer.

Returns
  A line number.

## ◆ get_line_index()

int Gtk::TextIterBase::get_line_index | ( |  | ) | const

Returns the byte index of the iterator, counting from the start of a newline-terminated line.

Remember that Gtk::TextBuffer encodes text in UTF-8, and that characters can require a variable number of bytes to represent.

Returns
  Distance from start of line, in bytes.

## ◆ get_line_offset()

int Gtk::TextIterBase::get_line_offset | ( |  | ) | const

Returns the character offset of the iterator, counting from the start of a newline-terminated line.

The first character on the line has offset 0.

Returns
  Offset from start of line.

## ◆ get_offset()

int Gtk::TextIterBase::get_offset | ( |  | ) | const

Returns the character offset of an iterator.

Each character in a Gtk::TextBuffer has an offset, starting with 0 for the first character in the buffer. Use Gtk::TextBuffer::get_iter_at_offset() to convert an offset back into an iterator.

Returns
  A character offset.

## ◆ get_slice()

Glib::ustring Gtk::TextIterBase::get_slice | ( | const TextIterBase & | end | ) | const

Returns the text in the given range.

A “slice” is an array of characters encoded in UTF-8 format, including the Unicode “unknown” character 0xFFFC for iterable non-character elements in the buffer, such as images. Because images are encoded in the slice, byte and character offsets in the returned array will correspond to byte offsets in the text buffer. Note that 0xFFFC can occur in normal text as well, so it is not a reliable indicator that a paintable or widget is in the buffer.

Parameters

  end | Iterator at end of a range.

Returns
  Slice of text from the buffer.

## ◆ get_text()

Glib::ustring Gtk::TextIterBase::get_text | ( | const TextIterBase & | end | ) | const

Returns text in the given range.

If the range contains non-text elements such as images, the character and byte offsets in the returned string will not correspond to character and byte offsets in the buffer. If you want offsets to correspond, see get_slice().

Parameters

  end | Iterator at end of a range.

Returns
  Array of characters from the buffer.

## ◆ get_type()

GType Gtk::TextIterBase::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_visible_line_index()

int Gtk::TextIterBase::get_visible_line_index | ( |  | ) | const

Returns the number of bytes from the start of the line to the given iter, not counting bytes that are invisible due to tags with the “invisible” flag toggled on.

Returns
  Byte index of iter with respect to the start of the line.

## ◆ get_visible_line_offset()

int Gtk::TextIterBase::get_visible_line_offset | ( |  | ) | const

Returns the offset in characters from the start of the line to the given iter, not counting characters that are invisible due to tags with the “invisible” flag toggled on.

Returns
  Offset in visible characters from the start of the line.

## ◆ get_visible_slice()

Glib::ustring Gtk::TextIterBase::get_visible_slice | ( | const TextIterBase & | end | ) | const

Returns visible text in the given range.

Like get_slice(), but invisible text is not included. Invisible text is usually invisible because a Gtk::TextTag with the “invisible” attribute turned on has been applied to it.

Parameters

  end | Iterator at end of range.

Returns
  Slice of text from the buffer.

## ◆ get_visible_text()

Glib::ustring Gtk::TextIterBase::get_visible_text | ( | const TextIterBase & | end | ) | const

Returns visible text in the given range.

Like get_text(), but invisible text is not included. Invisible text is usually invisible because a Gtk::TextTag with the “invisible” attribute turned on has been applied to it.

Parameters

  end | Iterator at end of range.

Returns
  String containing visible text in the range.

## ◆ gobj() [1/2]

GtkTextIter * Gtk::TextIterBase::gobj | ( |  | ) |
| inline

Provides access to the underlying C instance.

## ◆ gobj() [2/2]

const GtkTextIter * Gtk::TextIterBase::gobj | ( |  | ) | const
| inline

Provides access to the underlying C instance.

## ◆ has_tag()

bool Gtk::TextIterBase::has_tag | ( | const Glib::RefPtr< const TextTag > & | tag | ) | const

Returns true if iter points to a character that is part of a range tagged with tag.

See also starts_tag() and ends_tag().

Parameters

  tag | A Gtk::TextTag.

Returns
  Whether iter is tagged with tag.

## ◆ in_range()

bool Gtk::TextIterBase::in_range | ( | const TextIterBase & | start,
|  | const TextIterBase & | end ) const

Checks whether iter falls in the range [ start, end).

start and end must be in ascending order.

Parameters

  start | Start of range.
  end | End of range.

Returns
  true if iter is in the range.

## ◆ inside_sentence()

bool Gtk::TextIterBase::inside_sentence | ( |  | ) | const

Determines whether iter is inside a sentence (as opposed to in between two sentences, e.g. after a period and before the first letter of the next sentence).

Sentence boundaries are determined by Pango and should be correct for nearly any language.

Returns
  true if iter is inside a sentence.

## ◆ inside_word()

bool Gtk::TextIterBase::inside_word | ( |  | ) | const

Determines whether the character pointed by iter is part of a natural-language word (as opposed to say inside some whitespace).

Word breaks are determined by Pango and should be correct for nearly any language.

Note that if starts_word() returns true, then this function returns true too, since iter points to the first character of the word.

Returns
  true if iter is inside a word.

## ◆ is_cursor_position()

bool Gtk::TextIterBase::is_cursor_position | ( |  | ) | const

Determine if iter is at a cursor position.

See forward_cursor_position() or Pango::LogAttr or pango_break() for details on what a cursor position is.

Returns
  true if the cursor can be placed at iter.

## ◆ is_end()

bool Gtk::TextIterBase::is_end | ( |  | ) | const

Returns true if iter is the end iterator.

This means it is one past the last dereferenceable iterator in the buffer. is_end() is the most efficient way to check whether an iterator is the end iterator.

Returns
  Whether iter is the end iterator.

## ◆ is_start()

bool Gtk::TextIterBase::is_start | ( |  | ) | const

Returns true if iter is the first iterator in the buffer.

Returns
  Whether iter is the first in the buffer.

## ◆ operator bool()

Gtk::TextIterBase::operator bool | ( |  | ) | const
| explicit

Alias for !is_end().

For instance,

if (textiter)
do_something();

Since gtkmm 3.22

## ◆ operator*()

value_type Gtk::TextIterBase::operator* | ( |  | ) | const
| inline

Alias for get_char().

## ◆ operator=() [1/2]

TextIterBase & Gtk::TextIterBase::operator= | ( | const TextIterBase & | other | ) |
| noexcept

## ◆ operator=() [2/2]

TextIterBase & Gtk::TextIterBase::operator= | ( | TextIterBase && | other | ) |
| noexcept

## ◆ set_line()

void Gtk::TextIterBase::set_line | ( | int | line_number | ) |

Moves iterator iter to the start of the line line_number.

If line_number is negative or larger than or equal to the number of lines in the buffer, moves iter to the start of the last line in the buffer.

Parameters

  line_number | Line number (counted from 0).

## ◆ set_line_index()

void Gtk::TextIterBase::set_line_index | ( | int | byte_on_line | ) |

Same as set_line_offset(), but works with a byte index.

The given byte index must be at the start of a character, it can’t be in the middle of a UTF-8 encoded character.

Parameters

  byte_on_line | A byte index relative to the start of iter’s current line.

## ◆ set_line_offset()

void Gtk::TextIterBase::set_line_offset | ( | int | char_on_line | ) |

Moves iter within a line, to a new character (not byte) offset.

The given character offset must be less than or equal to the number of characters in the line; if equal, iter moves to the start of the next line. See set_line_index() if you have a byte index rather than a character offset.

Parameters

  char_on_line | A character offset relative to the start of iter’s current line.

## ◆ set_offset()

void Gtk::TextIterBase::set_offset | ( | int | char_offset | ) |

Sets iter to point to char_offset.

char_offset counts from the start of the entire text buffer, starting with 0.

Parameters

  char_offset | A character number.

## ◆ set_visible_line_index()

void Gtk::TextIterBase::set_visible_line_index | ( | int | byte_on_line | ) |

Like set_line_index(), but the index is in visible bytes, i.e. text with a tag making it invisible is not counted in the index.

Parameters

  byte_on_line | A byte index.

## ◆ set_visible_line_offset()

void Gtk::TextIterBase::set_visible_line_offset | ( | int | char_on_line | ) |

Like set_line_offset(), but the offset is in visible characters, i.e. text with a tag making it invisible is not counted in the offset.

Parameters

  char_on_line | A character offset.

## ◆ starts_line()

bool Gtk::TextIterBase::starts_line | ( |  | ) | const

Returns true if iter begins a paragraph.

This is the case if get_line_offset() would return 0. However this function is potentially more efficient than get_line_offset(), because it doesn’t have to compute the offset, it just has to see whether it’s 0.

Returns
  Whether iter begins a line.

## ◆ starts_sentence()

bool Gtk::TextIterBase::starts_sentence | ( |  | ) | const

Determines whether iter begins a sentence.

Sentence boundaries are determined by Pango and should be correct for nearly any language.

Returns
  true if iter is at the start of a sentence.

## ◆ starts_tag()

bool Gtk::TextIterBase::starts_tag | ( | const Glib::RefPtr< const TextTag > & | tag = {} | ) | const

Returns true if tag is toggled on at exactly this point.

If tag is nullptr, returns true if any tag is toggled on at this point.

Note that if this function returns true, it means that iter is at the beginning of the tagged range, and that the character at iter is inside the tagged range. In other words, unlike ends_tag(), if this function returns true, has_tag() will also return true for the same parameters.

Parameters

  tag | A Gtk::TextTag.

Returns
  Whether iter is the start of a range tagged with tag.

## ◆ starts_word()

bool Gtk::TextIterBase::starts_word | ( |  | ) | const

Determines whether iter begins a natural-language word.

Word breaks are determined by Pango and should be correct for nearly any language.

Returns
  true if iter is at the start of a word.

## ◆ toggles_tag()

bool Gtk::TextIterBase::toggles_tag | ( | const Glib::RefPtr< const TextTag > & | tag = {} | ) | const

Gets whether a range with tag applied to it begins or ends at iter.

This is equivalent to (starts_tag() || ends_tag())

Parameters

  tag | A Gtk::TextTag.

Returns
  Whether tag is toggled on or off at iter.

## Friends And Related Symbol Documentation

## ◆ operator!=()

bool operator!= | ( | const TextIterBase & | lhs,
|  | const TextIterBase & | rhs )
| related

Parameters

  lhs | The left-hand side
  rhs | The right-hand side

Returns
  The result

## ◆ operator<()

bool operator< | ( | const TextIterBase & | lhs,
|  | const TextIterBase & | rhs )
| related

Parameters

  lhs | The left-hand side
  rhs | The right-hand side

Returns
  The result

## ◆ operator<=()

bool operator<= | ( | const TextIterBase & | lhs,
|  | const TextIterBase & | rhs )
| related

Parameters

  lhs | The left-hand side
  rhs | The right-hand side

Returns
  The result

## ◆ operator==()

bool operator== | ( | const TextIterBase & | lhs,
|  | const TextIterBase & | rhs )
| related

Parameters

  lhs | The left-hand side
  rhs | The right-hand side

Returns
  The result

## ◆ operator>()

bool operator> | ( | const TextIterBase & | lhs,
|  | const TextIterBase & | rhs )
| related

Parameters

  lhs | The left-hand side
  rhs | The right-hand side

Returns
  The result

## ◆ operator>=()

bool operator>= | ( | const TextIterBase & | lhs,
|  | const TextIterBase & | rhs )
| related

Parameters

  lhs | The left-hand side
  rhs | The right-hand side

Returns
  The result

## ◆ wrap() [1/2]

const Gtk::TextIterBase & wrap | ( | const GtkTextIter * | object | ) |
| related

Parameters

  object | The C instance

Returns
  A C++ instance that wraps this C instance.

## ◆ wrap() [2/2]

Gtk::TextIterBase & wrap | ( | GtkTextIter * | object | ) |
| related

Parameters

  object | The C instance

Returns
  A C++ instance that wraps this C instance.

## Member Data Documentation

## ◆ gobject_

GtkTextIter Gtk::TextIterBase::gobject_
| protected